unit lib1;
(*
Tato jednotka obsahuje procedury a funkce pro prevody mezi soustavami
a jeste nekolik jinych veci
*)
interface
type Retezec = string[150];   (* Typ Retezec *)
     SouborTextovy = text;
     SouborZnaku = file of char;
     TypSymboly = array [0..35] of char;
     (*
     V tomto poli jsou ulozeny symboly
     pro cisla v soustavach o zakladu vyssim nez 10
     *)
var Symboly:TypSymboly;
function  PrevedDesitku(z:integer):Retezec;
(* Prevede cislo 10 do libovolne soustavy *)
procedure OdsekniDecMista(var r:Retezec; PocetZbyvajicich:integer);
(* odsekne desetinna mista cisla tak, ze zbude jen 10 des. mist *)
procedure OddelDesetinnouCast(var r,r2:Retezec);
(*Oddeli desetinnou cast cisla r a vlozi ji do r2 *)
function SeberNulyZePredu(r:Retezec):Retezec;
(* pokud predni znaky cisla r jsou "0", umaze je *)
function SeberNuly(r:Retezec):Retezec;
(* Umaze nuly v des. cisle (napr. z 0,75000 udela 0,75 *)
function Mocnina(z:Retezec; e,Zaklad:integer; r2:Retezec):Retezec;
(* Umi libovolnou mocninu a to i zapornu *)
function PrevedSymbol(s:char):longint;
(* prevede symbol na longint (napr. z A udela 10 ) *)
function PrevedCislo(c:longint):char;
(* prevede cislo na symbol (napr. z 10ti udela A) *)
function NaC(r:Retezec):longint;
(* prevede cislo na retezec *)
function NaR(c:longint):Retezec;
(* prevede retezec na cislo *)
procedure PrevedDoSoustavy(var r:Retezec; z1,z2:integer);
(* prevadi z jedne soustavy do druhe *)
function PrevedNaAx10n(Cislo:Retezec; Soustava:integer):Retezec;
(* prevede cislo na A * (Zaklad)X (napr. z 100000000 udela 1e+8) *)
function PrevedDoNormalTvaru(Cislo:Retezec; Soustava:integer):Retezec;
(* Opak minule funkce *)
function JeVRetezci(r:Retezec; zn:char):boolean;
(* zjisti, zda znak je v retezci*)
function SpodniJeMensi(r1,r2:Retezec; z:integer):boolean;
(* Dokaze porovnat retezce jako cisla (nazev je z pisemneho odcitani) *)
function PoziceZnaku2(var r:Retezec; zn:char):integer;
(* vrati pozici urc. znaku v retezci *)
function KontrolaVelikosti(Cislo:Retezec; Soustava:integer):integer;
(* Vrati velikost exponentu cisla v desitkove soustave *)
function PoziceZnaku(var r:Retezec; zn:char):integer;
(*
Tuto funkci pouzivam pro zjisteni pozice "," v cisle
Vrati pozici "," a pokud se tam "," nenachazi, prida k retezci ",0"
*)
function readkey2:integer;
(* Vylepsena Readkey z CRT *)
function keypressed:boolean;
(* zjisti, zda byla stisknuty klavesa *)
function readkey:char;
(* vraci stisknutou klavesu *)
implementation
uses lib2;
function keypressed:boolean;
 begin
  asm
   mov ah,01h
   int 16h
    je @1
   mov @result,0FFh
   jmp @2
   @1:
   mov @result,0h
   @2:
  end;
 end;
function readkey:char;
 begin
  asm
   mov ah,0h
   int 16h
   mov @result,al
  end
 end;
function readkey2:integer;
var c:char;
begin
c:=readkey;
if (ord(c) = 0) then
   begin
   c:=readkey;
   readkey2:=ord(c)+256;
   end
else readkey2:=ord(c);
end;
function PoziceZnaku(var r:Retezec; zn:char):integer;
var i:integer;
begin
for i:=1 to length(r) do  (* prohlizi retezec, kdyz najde   *)
    begin                 (* dany znak, ulozi promenou i do *)
    if r[i] = zn then     (* funkce a opusti cyklus         *)
       begin
       PoziceZnaku:=i;
       break;
       end;
    end;
if i = length(r) then    (* pokud znak v retezci neni, prida  *)
   begin                 (* na konec znaky ",0"               *)
   r:=r+','+'0';
   PoziceZnaku:=length(r)-1;
   end;
end;
function PoziceZnaku2(var r:Retezec; zn:char):integer;
var i,b:integer;
begin
for i:=1 to length(r) do    (* algoritmus totozny s predchozim podprg. *)
    begin
    if r[i] = zn then
       begin
       PoziceZnaku2:=i;
       break;
       end;
   end;
if i = length(r) then PoziceZnaku2:=0;
end;
function SpodniJeMensi(r1,r2:Retezec; z:integer):boolean;
label 1;
var i,j,Delsi:integer;
    Opacne:boolean;
begin
Opacne:=false;
if r1 = '' then SpodniJeMensi:=false        (* Zjisti, zda jeden z retezcu *)
else if r2 = '' then SpodniJeMensi:=true    (* neni prazdny                *)
else if (r1[1] = '-') and (r2[1] <> '-') then SpodniJeMensi:=false
else if (r2[1] = '-') and (r1[1] <> '-') then SpodniJeMensi:=true
else if (r1[1] = '-') and (r2[1] = '-') then
     begin
     Opacne:=true;
     delete(r1,1,1);
     delete(r2,1,1);
     goto 1;
     end
else begin
1:
if PoziceZnaku(r1,',') > PoziceZnaku(r2,',') then  (* Vyrovnava delky *)
   while not (PoziceZnaku(r1,',') = PoziceZnaku(r2,',')) do
            r2:='0'+r2
   else while not (PoziceZnaku(r1,',') = PoziceZnaku(r2,',')) do
              r1:='0'+r1;
   if length(r1)-length(r2) > 0 then Delsi:=length(r1)
   else Delsi:=length(r2);
   if length(r1) < length(r2) then
      while not (length(r1) = length(r2)) do
            r1:=r1+'0';
   for i:=1 to Delsi do                              (* Porovnava       *)
       begin                                         (* ciselne hodnoty *)
       if PrevedSymbol(r1[i]) = PrevedSymbol(r2[i]) then  begin end;
       if PrevedSymbol(r1[i]) > PrevedSymbol(r2[i]) then
          begin
          if Opacne then SpodniJeMensi:=false
          else SpodniJeMensi:=true;
          break;
          end;
       if PrevedSymbol(r1[i]) < PrevedSymbol(r2[i]) then
          begin
          if Opacne then SpodniJeMensi:=true
          else SpodniJeMensi:=false;
          break;
          end;
       end;
end;
end;
function Mocnina(z:Retezec; e,Zaklad:integer; r2:Retezec):Retezec;
var i:longint;
    j:Retezec;
    Zapor:boolean;
begin
Zapor:=false;
if e<0 then    (* Zjistuje, zda je exponent zaporny *)
   begin
   Zapor:=true;
   e:=abs(e);
   end;
if e = 0 then Mocnina:='1'   (* kdyz exponent = 0 *)
else begin
     j:=z;
     for i:=1 to e-1 do j:=NasobPisemne(j,z,Zaklad); (* provadi umocnovani *)
     Mocnina:=j;
     end;
if Zapor then Mocnina:=DelPisemne(r2,j,Zaklad);
   (* Zmeni na zaporne umocnovani *)
end;
function NaC(r:Retezec):longint;
var code:integer;
    c:longint;
begin
val(r,c,code);   (* no comment *)
NaC:=c;
end;
function NaR(c:longint):Retezec;
var d:Retezec;
begin
str(c,d);      (* no comment *)
NaR:=d;
end;
function PrevedSymbol(s:char):longint;
var i:integer;
begin
for i:=0 to 35 do            (* hleda v poli Symboly. Pokud se znak s     *)
    if s = Symboly[i] then   (* bude shodovat s nejakym znakem v poli,    *)
       begin                 (* do funkce se ulozi hodnota tohoto symbolu *)
       PrevedSymbol:=i;      (* a cyklus se ukonci                        *)
       break;
       end;
end;
function PrevedCislo(c:longint):char;
begin
PrevedCislo:=Symboly[c];  (* Prevadi hodnotu cisla na symbol *)
end;                      (* (napr. 15 na F atd.)            *)
procedure OddelDesetinnouCast(var r,r2:Retezec);
var i:integer;
begin
i:=1;
while not ((r[i] = ',') or (i = length(r))) do i:=i+1; (* Najde "," v r *)
if i<>length(r) then
   begin                            (* pravou stranu vlozi do r2 *)
   r2:=copy(r,i+1,length(r)-i);
   delete(r,i,length(r)-i+1);
   end
else r2:='0'; (* Toto se stane, kdyz carka nebyla nalezena (=0 des. mist) *)
end;
function SeberNuly(r:Retezec):Retezec;
var i:longint;
begin
if (PoziceZnaku2(r,',') <> 0) then  (* pokud neni pozice carky v r 0 *)
   begin                            (* (coz sen nikdy nemuze stat)   *)
   i:=length(r);
   while  r[i] = '0' do             (* dokud r[i] = '0', smaz r[i] *)
          begin
          delete(r,i,1);
          i:=i-1;
          end;
   end;
if r[length(r)] = ',' then   (* pokud je na konci retezce ",", smaz ji *)
   delete(r,length(r),1);
SeberNuly:=r;
end;
function SeberNulyZePredu(r:Retezec):Retezec;
var i,j:longint;
begin
if r[1] <> '-' then i:=1
else i:=2;
for j:=i to length(r) do        (* dokud je r[i] '0', maz r[i] *)
    begin
    if r[i] = '0' then delete(r,i,1)
    else  break;
    end;
if r[i] = ',' then insert('0',r,1);  (* Kdyz je prvnim nebo druhym znakem *)
SeberNulyZePredu:=r;                 (* retezce ',', smaz ji              *)
end;
function PrevedSymbol2(zn:char; z:integer):Retezec;
var s:SouborTextovy;
    Radek,Cislo,i:integer;
    zn2:char;
begin
if ord(zn)-48 < z then PrevedSymbol2:=zn   (* hleda v dat. souboru *)
else begin                                 (* zapisy cisel 0 az 9  *)
      assign(s,'prevody.dat');             (* v jinych soustavach  *)
     reset(s);                             (* (urychluje vypocet)  *)
     Radek:=2;
     while not (Radek = z) do
           begin
           readln(s);
           Radek:=Radek+1;
           end;
     for i:=1 to ord(zn)-48 do
         begin
         read(s,Cislo);
         read(s,zn2);
         PrevedSymbol2:=NaR(Cislo);
         end;
     close(s);
     end;
end;
function PrevedDesitku(z:integer):Retezec;
begin                           (* Myslim, ze je to jasne *)
case z of
     2: PrevedDesitku:='1010';
     3: PrevedDesitku:='101';
     4: PrevedDesitku:='22';
     5: PrevedDesitku:='20';
     6: PrevedDesitku:='14';
     7: PrevedDesitku:='13';
     8: PrevedDesitku:='12';
     9: PrevedDesitku:='11';
    10: PrevedDesitku:='10';
    else PrevedDesitku:='A';
    end;
end;
procedure PrevedDoSoustavy(var r:Retezec; z1,z2:integer);
var pr,pr2,pr4,pr3,Znamenko:Retezec;
    i,j,pocet,pom:longint;
begin
if r[1] = '+' then
   delete(r,1,1);
if r <> '' then
begin
r:=PrevedDoNormalTvaru(r,z1); (* Prevede r z tvaru a*10n *)
Znamenko:='';
pr:='0';              (* priprava promenych *)
pr4:='';
if z1 <> z2 then     (* zkouma, zda neprevadime mezi soustavami *)
begin                (* o stejnem zakladu                       *)
if r[1] = '-' then
   begin
   delete(r,1,1);
   Znamenko:='-';
   end;
   if z1 <> 10 then    (* Pokud soustava, ve ktere se cislo nachazi, *)
      begin            (* neni desitkova, prevede cislo do ni        *)
      OddelDesetinnouCast(r,pr4); (* Prevadim des.cast cisla zvlast    *)
      for i:=1 to length(r) do
      (* Vlasti algoritmus, *)
      (* cislo XYZ by prevedl jako X*10*10+Y*10+Z *)
      (* (X,Y,Z jsou nejaka cisla) *)
          pr:=SectiPisemne(pr,NasobPisemne(NaR(PrevedSymbol(r[i])),Mocnina(NaR(z1),length(r)-i,10,'1'),10),10);
      r:=pr;
      pr:='0';
      OddelDesetinnouCast(r,pr3);
      for i:=1 to length(pr4) do
          pr:=SectiPisemne(pr,Mocnina(NaR(z1),-i,10,NaR(PrevedSymbol(pr4[i]))),10);
      (* zde prevede do desitkove i des. mista *)
      r:=SectiPisemne(r,pr,10);
      r:=SeberNuly(r);
      end;
   if z2 <> 10 then
   begin
   pr:='0,0';
   OddelDesetinnouCast(r,pr3);   (* Prevod z desitkove *)
   j:=length(r)-1;
   for i:=1 to length(r) do
         begin
         pr:=SectiPisemne(pr,NasobPisemne(PrevedSymbol2(r[i],z2),Mocnina(PrevedDesitku(z2),j,z2,'1'),z2),z2);
         j:=j-1;
         end;
   pr4:=pr;
   pr:='0,0';
   pr2:='0';
   for i:=1 to length(pr3) do
       pr:=SectiPisemne(pr,NasobPisemne(PrevedSymbol2(pr3[i],z2),Mocnina(PrevedDeSitku(z2),length(pr3)-i+1,z2,'1'),z2),z2);
   pr2:=Mocnina(PrevedDesitku(z2),length(pr3)+1,z2,'1');
   pr:=DelPisemne(pr,pr2,z2);
   r:=SectiPisemne(pr4,pr,z2);
   end;
r:=Znamenko+r;
r:=SeberNuly(r);
end;
end;
end;
procedure OdsekniDecMista(var r:Retezec; PocetZbyvajicich:integer);
var Carka:integer;
    Pocet:integer;
begin
Carka:=PoziceZnaku2(r,',');
if Carka <> 0 then
   begin
   Pocet:=length(r)-Carka;
   while not (Pocet <= PocetZbyvajicich) do
         begin
         delete(r,length(r),1);
         Pocet:=Pocet-1;
         end;
   end
end;
function KontrolaVelikosti(Cislo:Retezec;Soustava:integer):integer;
var Min,Max,Pozice,ErrCode,Radek:integer;
    s:text;
    Znamenko,Exponent,Cislo2:Retezec;
    Priznak: (Male,Velke);
begin
Znamenko:='';
if Cislo[1] = '-' then
   begin
   Znamenko:='-';
   delete(Cislo,1,1);
   end;
ErrCode:=0;
KontrolaVelikosti:=0;
case Soustava of
     2: Max:=7;
     3: Max:=4;
     4..6: Max:=3;
     7..22: Max:=2;
     23..36: Max:=1;
     else ErrCode:=1;
    end;
case Soustava of
     2: Min:=7;
     3: Min:=4;
     4..5: Min:=3;
     6..16: Min:=2;
    17..36: Min:=1;
    else ErrCode:=1;
     end;
if (JeVRetezci(Cislo,'+')) then
   if length(Cislo)-PoziceZnaku2(Cislo,'+') > Max then
      ErrCode:=1;
if (JeVRetezci(Cislo,'-')) and
   (PoziceZnaku2(Cislo,'-')<>1) then
   if length(Cislo)-PoziceZnaku2(Cislo,'-') > Min then
      ErrCode:=1;
if ErrCode = 0 then
begin
Cislo:=PrevedNaAx10n(Cislo,Soustava);
if not JeVRetezci(Cislo,'e') then
   Cislo:=PrevedNaAx10n(Cislo,Soustava);
if JeVRetezci(Cislo,'e') then
   begin
   Pozice:=PoziceZnaku2(Cislo,'e');
   case Cislo[Pozice+1] of
        '+' : begin
              assign(s,'hranice1.dat');
              Exponent:=Copy(Cislo,Pozice+2,length(Cislo)-(Pozice+1));
              if length(Exponent)> Max then ErrCode:=1;
              Priznak:=Velke;
              end;
        '-' : begin
              inc(Pozice);
              assign(s,'hranice2.dat');
              Exponent:=Copy(Cislo,Pozice+1,length(Cislo)-Pozice);
              if length(Exponent)> Min then ErrCode:=2;
              Priznak:=Male;
              end;
        end;
   if ErrCode = 0 then
      begin
      Cislo:=PrevedDoNormalTvaru(Cislo,Soustava);
      reset(s);
      Radek:=2;
      while not (Radek = Soustava) do
            begin
            readln(s);
            inc(Radek);
            end;
      readln(s,Cislo2);
      if (SpodniJeMensi(Cislo,Cislo2,Soustava)) and (Priznak = Male) or
      not (SpodniJeMensi(Cislo,Cislo2,Soustava)) and (Priznak = Velke) then
         KontrolaVelikosti:=0
      else KontrolaVelikosti:=1;
      close(s);
      end
   else KontrolaVelikosti:=1;
   end;
Cislo:=Znamenko+Cislo;
end
else KontrolaVelikosti:=1;
end;
var s:SouborZnaku;
    Ret:Retezec;
function PrevedNaAx10n(Cislo:Retezec; Soustava:integer):Retezec;
var c,i,exponent:integer;
    PomExp:Retezec;
    Znamenko:Retezec;
begin
if JeVRetezci(Cislo,'e') then Cislo:=PrevedDoNormalTvaru(Cislo,Soustava);
Znamenko:='';
if Cislo = '' then PrevedNaAx10n:=''
else if Cislo = '0' then prevedNaAx10n:='0'
else begin
exponent:=0;
if Cislo[1] = '-' then
   begin
   Znamenko:='-';
   delete(Cislo,1,1);
   end;
c:=PoziceZnaku2(Cislo,',');
if (c>15) or (Cislo[1] = '0') or (length(Cislo)>10) then
   begin
   if Cislo[2] <> ',' then
      begin
      while not ((cislo[2] = ',') or (length(Cislo) = 1)) do
            begin
            inc(exponent);
            Cislo:=DelPisemne(Cislo,'10',Soustava);
            end;
            PomExp:=NaR(exponent);
            PrevedDoSoustavy(PomExp,10,Soustava);
           if length(Cislo)>12 then delete(Cislo,12,length(Cislo)-11);
         Cislo:=Cislo+'e+'+PomExp;
         PrevedNaAx10n:=Znamenko+Cislo;
      end
   else if Cislo[1] = '0' then
           begin
           while not (Cislo[1] <> '0') do
                 begin
                 dec(exponent);
                 Cislo:=NasobPisemne(Cislo,'10',Soustava);
                 end;
           PomExp:=NaR(exponent);
           PrevedDoSoustavy(PomExp,10,Soustava);
           if length(Cislo)>12 then delete(Cislo,12,length(Cislo)-11);
           Cislo:=Cislo+'e'+PomExp;
           PrevedNaAx10n:=Znamenko+Cislo;
           end
   else begin
        OdsekniDecMista(Cislo,10);
        PrevedNaAx10n:=Znamenko+Cislo;
        end;
   end
else PrevedNaAx10n:=Znamenko+Cislo;
end;
end;
function PrevedDoNormalTvaru(Cislo:Retezec; Soustava:integer):Retezec;
var c,exponent:integer;
    Pom:Retezec;
    Znamenko:Retezec;
begin
if Cislo = '' then PrevedDoNormalTvaru:=''
else begin
Znamenko:='';
if Cislo[1] = '-' then
   begin
   Znamenko:='-';
   delete(Cislo,1,1);
   end;
c:=PoziceZnaku2(Cislo,'e');
if not (c = 0) then
   begin
   if Cislo[c+1] = '+' then Pom:=copy(Cislo,c+2,length(Cislo)-c-1)
   else Pom:=copy(Cislo,c+1,length(Cislo)-c);
   delete(Cislo,c,length(Cislo)-c+1);
   PrevedDoSoustavy(Pom,Soustava,10);
   exponent:=NaC(Pom);
   if exponent>0 then
      begin
      while not (exponent = 0) do
            begin
            dec(exponent);
            Cislo:=NasobPisemne(Cislo,'10',Soustava);
            end;
      PrevedDoNormalTvaru:=Znamenko+Cislo;
      end
   else if exponent < 0 then
         begin
         while not (exponent = 0) do
               begin
               inc(exponent);
               Cislo:=DelPisemne(Cislo,'10',Soustava);
               end;
         PrevedDoNormalTvaru:=Znamenko+Cislo;
         end
   else PrevedDoNormalTvaru:=Znamenko+Cislo;
   end
else PrevedDoNormalTvaru:=Znamenko+Cislo;
end;
end;
function JeVRetezci(r:Retezec; zn:char):boolean;
begin
if (PoziceZnaku2(r,zn) = 0) or
   (r = '') then JeVRetezci:=false
else JeVRetezci:=true;
end;
begin
assign(s,'symboly.dat');
reset(s);
while not eof(s) do
      read(s,Symboly[filepos(s)]);
close(s);
end.