unit lib3;
(*
Tato jednotka obsahuje procedury a funkce pro vypocet
ciselneho vyrazu a pro kontrolu vstupu
Jednotka je pouze moje vlastni dilo
*)
interface
uses lib1;
const Soustava = ['0'..'9'];
      (* Potrebne pro kontrolu soustavy *)
      Prevod = ['0'..'9','A'..'Z',',','+','-','e'];
      (* potrebne pro kontrolu cisel *)
      Vyraz = ['0'..'9','A'..'Z',',','+','-','e','(',')','*','/'];
      (* potrebne pro kontrolu vyrazu *)
      Cisla = ['0'..'9','A'..'Z'];
type Mnozina = set of '('..'z';
     Pole = array [0..26] of ^Retezec;
var ErrCode:integer;
    Scitance:Pole;
procedure ArOperace(Typ:char);
(* Zajistuje ctyri zakladni aritmeticke operace *)
function Vypocet(r:Retezec; z:integer):Retezec;
(* Zajisti vypocet vyrazu *)
procedure ClrKlBuffer;
(* Vyprazdni buffer klavesnice *)
procedure VypisVDesitkoveSoustave(r:Pole);
(*
Vypise cisla, se kterymi se provadely ar. operace pod sebe
v desitkove soustave
*)
function KontrolaRetezce(r:Retezec; MozneSymboly:Mnozina):boolean;
(*
Zkontroluje, zda bylo cislo spravne zapsano a zda neni moc velke
Druhy parametr udava, zda je toto cislo zaklad soustavy, nebo se
pouzije pri ar. operacich, nebo je to vyraz
*)
procedure CreateMenu;
(*  Vytvori hlavni menu *)
function PrevedVyrazDoDesitkoveSoustavy(r:Retezec; z:integer):Retezec;
(* Prevede ciselny vyraz do desitkove soustavy *)
implementation
uses crt,lib2,windws;
procedure ClrKlBuffer;
var i:integer;
begin
i:=0;
while not (i = 1) do
      begin
      if keypressed then readkey
      else break;
      end;
end;
procedure VypisVDesitkoveSoustave(r:Pole);
var i,j,k,Max:integer;
begin
Max:=26;
WNastavBarvuTextu(14);
WNastavBarvuPozadi(7);
OknoPisRetezec(1,'Soustava',220,20);
WNastavBarvuTextu(8);
OknoPisRetezec(1,'10',220,30);
WNastavBarvuTextu(14);;
OknoPisRetezec(1,'Cisla',220,40);
WNastavBarvuTextu(8);
OknoPisRetezec(1,r[0]^,100,380);
for k:=2 to Max do
for i:=2 to Max do
    begin
    if r[i]^ = '' then
       begin
       for j:=i to Max-1 do
           r[j]^:=r[j+1]^;
       Dec(Max);
       end;
    if Max<=i then break;
    end;
for i:=2 to Max do
    begin
    if r[i]^ = '' then break
    else OknoPisRetezec(1,r[i]^,220,60+i*11);
    end;
WNastavBarvuTextu(14);
OknoPisRetezec(1,'Vysledek',220,60+(i+1)*11);
WNastavBarvuTextu(8);
OknoPisRetezec(1,r[1]^,220,60+(i+2)*11);
end;
procedure OmezSymbolyPodleSoustavy(var Symboly:Mnozina; z:integer );
var pom:char;
begin
pom:=PrevedCislo(z-1);
if not (pom = 'Z') then
   Symboly:=Symboly-[chr(ord(Pom)+1)..'Z'];
end;
function KontrolaRetezce(r:Retezec; MozneSymboly:Mnozina):boolean;
label konec;
const NesmiBytNaKonci = [',','-','+','e'];
var i:integer;
    Pom:Retezec;
    Zavorka:integer;
    Carka,Exponent:boolean;
begin
Exponent:=false;
Carka:=false;
Zavorka:=0;
KontrolaRetezce:=true;
if r[length(r)] in NesmiBytNaKonci then
   begin
   ErrMessage(2,'Symbol [e],[,],[-],[+] nesmi byt poslednim znakem cisla');
   KontrolaRetezce:=false;
   goto konec;
   end;
if MozneSymboly = Soustava then {Kontrola zadani soustavy}
   begin
   if r = '' then
      begin
      ErrMessage(2,'Nebyla zadana soustava');
      KontrolaRetezce:=false;
      goto konec;
      end
   else for i:=1 to length(r) do
       begin
       if not (r[i] in MozneSymboly) then
          begin
          ErrMessage(2,'Nepripustny symbol');
          KontrolaRetezce:=false;
          goto konec;
          end;
       end;
   if (NaC(r) > 36) or (NaC(r)<2) then
      begin
      ErrMessage(2,'Soustava neni v intervalu <2,36>');
      KontrolaRetezce:=false;
      goto konec;
      end;
   end;
if MozneSymboly = Prevod then { Kontrola cisla, ktere se bude prevadet}
   begin
   OmezSymbolyPodleSoustavy(MozneSymboly,NaC(Txt[1].Obsah));
   Pom:=r;
   for i:=1 to length(r) do
       begin
       if not (r[i] in MozneSymboly) then
          begin
          ErrMessage(2,'Nepripustny symbol');
          KontrolaRetezce:=false;
          i:=length(r);
          end
       else begin
            case r[i] of
                 '0'..'9',
                 'A'..'Z' : begin
                            if (r[i-1] = 'e') then
                               begin
                               ErrMessage(2,'Za znakem exponentu musi nasledovat [+] nebo [-]');
                               KontrolaRetezce:=false;
                               goto konec;
                               end;
                            end;
                      'e' : begin
                            if (i = 1) or (r[i-1] = ',') or
                               (Exponent) then
                               begin
                               ErrMessage(2,'Pred znakem exponentu nesmi byt [,] nebo zacatek cisla');
                               KontrolaRetezce:=false;
                               goto konec;
                               end
                            else Exponent:=true;
                            end;
                      ',' : begin
                            if not (i<>1) or (Carka) or
                               (Exponent) then
                               begin
                               ErrMessage(2,'Exponent nesmi byt desetinne cislo, nebo znak [,] je jiz v cisle obsazen');
                               KontrolaRetezce:=false;
                               goto konec;
                               end
                            else Carka:=true;
                            end;
                 '+','-' : begin
                           if ((Exponent = false) or (r[i-1] <> 'e')) and
                              not ((i = 1) and (r[i] = '-'))      then
                              begin
                              ErrMessage(2,'Znaky [+] a [-] jsou pripustne pouze za znakem [e]');
                              KontrolaRetezce:=false;
                              goto konec;
                              end;
                           end;
                 end;
            end;
       end;
   if (KontrolaVelikosti(r,NaC(Txt[1].Obsah)) <> 0) then
      begin
      ErrMessage(2,'Prilis vysoke / nizke cislo');
      KontrolaRetezce:=false;
      goto konec;
      end;
   end;
if MozneSymboly = Vyraz then { Kontrola vyrazu}
   begin
   OmezSymbolyPodleSoustavy(MozneSymboly,NaC(Txt[1].Obsah));
   if r = '' then
      begin
      ErrMessage(2,'Nebyl zadan vyraz');
      KontrolaRetezce:=false;
      goto konec;
      end;
   for i:=1 to length(r) do
       if r[i] = 'e' then
          begin
          if not (r[i+1] = '+') and not (r[i+1] = '-') then
             begin
             ErrMessage(2,'Za znakem exponentu musi nasledovat [+], nebo [-]');
             KontrolaRetezce:=false;
             goto konec;
             end;
          end;
   for i:=1 to length(r) do
       begin
       if not (r[i] in MozneSymboly) then
          begin
          KontrolaRetezce:=false;
          ErrMessage(2,'Nepripustny symbol');
          goto konec;
          end;
       case r[i] of
            '0'..'9',
            'A'..'Z' : begin
                       if (r[i-1] = 'e') then
                          begin
                          ErrMessage(2,'Za znakem exponentu musi nasledovat [+], nebo [-]');
                          KontrolaRetezce:=false;
                          goto konec;
                          end;
                       end;
            ','      : begin
                       if (Carka) or (i = 1) or (r[i-1] = 'e') or
                          (exponent) or not (r[i-1] in Soustava+['A'..'Z'])
                          or (i = length(r)) then
                             begin
                             ErrMessage(2,'Chybne umisteni [,]');
                             KontrolaRetezce:=false;
                             goto konec;
                             end
                       else Carka:=true;
                       end;
            'e'      : begin
                       if (exponent) or (i = 1) or (i = length(r)) or
                          ((r[i+1]<>'-') and (r[i+1]<>'+')) then
                          begin
                          ErrMessage(2,'Chybne umisteni znaku exponentu');
                          KontrolaRetezce:=false;
                          goto konec;
                          end
                       else Exponent:=true;
                       end;
            '*','/' :  begin
                       if (i = 1) or (i = length(r)) or
                          not (r[i-1] in Soustava+['(',')']+['A'..'Z']) or
                          not (r[i+1] in Soustava+['(',')']+['A'..'Z']) then
                              begin
                              ErrMessage(2,'Chybne umisteni [*], nebo [/]');
                              KontrolaRetezce:=false;
                              goto konec;
                              end
                       else begin
                            Exponent:=false;
                            Carka:=false;
                            end;
                       end;
            '-','+' :  begin
                       if (((i = 1)and(r[i] = '+')) or (i = length(r)) or
                          not (r[i-1] in Soustava+['(',')','e']+['A'..'Z']) or
                          not (r[i+1] in Soustava+['(',')']+['A'..'Z'])) and
                          not ((r[i] = '-')and(i = 1)) then

                              begin
                              ErrMessage(2,'Chybne umisteni [+], nebo [-]');
                              KontrolaRetezce:=false;
                              goto konec;
                              end
                       else if not (r[i-1] = 'e') then
                               begin
                               Exponent:=false;
                               Carka:=false;
                               end;
                       end;
            '('      : begin
                       if     ((r[i-1] in [' '..'z']-['+','-','*','/','('])and
                              (i<>1)) or
                              (r[i+1] in ['*','/',')','+','e']) or
                              (i = length(r)) then
                              begin
                              ErrMessage(2,'Chybne umisteni [(]');
                              KontrolaRetezce:=false;
                              goto konec;
                              end
                       else begin
                            inc(Zavorka);
                            exponent:=false;
                            Carka:=false;
                            end;
                       end;
            ')'      : begin
                       if ((r[i+1] in [' '..'z']-['+','-','*','/',')'])and
                          (i<>length(r))) or
                          not (r[i-1] in Soustava+['A'..'Z',')']) or
                              (i = 1)              then
                              begin
                              ErrMessage(2,'Chybne umisteni [)]');
                              KontrolaRetezce:=false;
                              goto konec;
                              end
                          else begin
                               dec(Zavorka);
                               exponent:=false;
                               Carka:=false;
                               end;
                       end;

            end;
       end;
   if Zavorka <> 0 then
      begin
      ErrMessage(2,'Chybny pocet zavorek');
      KontrolaRetezce:=false;
      goto konec;
      end;
   end;
konec:
end;
function CisteCislo(r:Retezec):boolean;
(* Zjistuje zda retezec (cislo) obsahuje zavorky a jina znamenka *)
var i,code:integer;
begin
CisteCislo:=true;
if r[1] = '-' then delete(r,1,1);
for i:=1 to length(r) do
    begin
    if ((r[i]>='0') and (r[i]<='Z')) or
       (r[i] = ',') or
       ((r[i] = 'e')and(r[i+1]in['-','+'])and(i <> length(r))) or
       ((i<>1)and(r[i] in ['-','+'])and(r[i-1] = 'e')) then
    else CisteCislo:=false;
    end;
end;
function PrevedVyrazDoDesitkoveSoustavy(r:Retezec; z:integer):Retezec;
var i,Poz1,Poz2:integer;
    Znamenko:boolean;
    Result,Pom:Retezec;
begin
Znamenko:=false;
if r[1] = '-' then
   begin
   delete(r,1,1);
   Znamenko:=true;
   end;
Result:='';
Poz2:=0-1;
r:=r+'=';
if r[1] in Cisla then Poz1:=0
else Poz1:=0-1;
for i:=1 to length(r) do
    begin
    Pom:='';
    case r[i] of
         '+','-','*','/','(',')','=' :
            begin
            if (r[i-1] <> 'e') or (i =1) then
               if Poz1 = -1 then Poz1:=i
               else begin
                    Poz2:=i;
                    if Poz2-Poz1 > 1 then
                       begin
                       Pom:=copy(r,Poz1+1,Poz2-Poz1-1);
                       Pom:=PrevedDoNormalTvaru(Pom,z);
                       PrevedDoSoustavy(Pom,z,10);
                       Pom:=PrevedNaAx10n(Pom,10);
                       end;
                    Result:=Result+r[Poz1]+Pom;
                    if r[i] <> '=' then
                       Poz1:=Poz2;
                    end;
            end;
         end;
    end;
if not (Result[1] in Cisla+['(']) then delete(Result,1,1);
if Znamenko then Result:='-'+Result;
PrevedVyrazDoDesitkoveSoustavy:=Result;
end;
function Vypocet(r:Retezec; z:integer):Retezec;
label 1;
var Zavorka1,Zavorka2:integer;
    r2,r3:Retezec;
    i,j,k:integer;
begin
ErrCode:=0;
r2:='';
r3:='';
1:
    if (r[1] = '-') and (r[2] = '-') then
       begin
       delete(r,1,2);
       end
else if ((r[1] = '+') and (r[2] = '-')) or
        ((r[1] = '-') and (r[2] = '+')) then
        begin
        delete(r,1,2);
        insert('-',r,1);
        end;
for i:=1 to length(r) do
    begin
    if r[i] = '(' then Zavorka1:=i;
    if r[i] = ')' then
       begin
       Zavorka2:=i;
       r2:=Vypocet(copy(r,Zavorka1+1,Zavorka2-Zavorka1-1),z);
       delete(r,Zavorka1,Zavorka2-Zavorka1+1);
       insert(r2,r,Zavorka1);
       goto 1;
       end;
    end;
if i = length(r) then
   if not (CisteCislo(r)) and (Zprava.Stav = false) then ZobrazZpravu('Vyhodnocuji');
   while not (CisteCislo(r)) do
         begin
         i:=0;
         repeat
         i:=i+1;
         until (r[i] = '*') or
               (r[i] = '/') or
               (i = length(r));
         if i<>length(r) then
            begin
            r2:='';
            r3:='';
            j:=i-1;
            while not (((r[j] = '+') and (r[j-1] <> 'e')) or
                      ((r[j] = '-')and(j<>1)and(r[j-1] <> 'e')) or
                      (j = 0)) do
                  dec(j);
            k:=i+1;
            while not (((r[k] = '+')and(r[k-1] <> 'e')) or
                  ((r[k] = '-')and(k<>i+1)and(r[k-1] <> 'e')) or
                  (r[k] = '*') or (r[k] = '/') or
                  (k = length(r)+1)) do
                  inc(k);
            r2:=PrevedDoNormalTvaru(copy(r,j+1,i-j-1),z);
            r3:=PrevedDoNormalTvaru(copy(r,i+1,k-i-1),z);
            if (KontrolaVelikosti(PrevedNaAx10n(r2,z),z) <> 0) or
               (KontrolaVelikosti(PrevedNaAx10n(r3,z),z) <> 0) then
               begin
               ErrCode:=1;
               r:='Error';
               break;
               end;
            case r[i] of
                 '*' : r2:=NasobPisemne(r2,r3,z);
                 '/' : begin
                       if (SeberNulyZepredu(SeberNuly(r3)) <> '') then
                       r2:=DelPisemne(r2,r3,z)
                       else begin
                            ErrMessage(2,'Nelze delit nulou');
                            r:='Error2';
                            break;
                            end;
                       end;
                 end;
              if (KontrolaVelikosti(r2,z) <> 0) then
                 begin
                 ErrCode:=1;
                 r:='Error';
                 break;
                 end;
            r2:=PrevedNaAx10n(r2,z);
            delete(r,j+1,k-j-1);
            insert(PrevedNaAx10n(r2,z),r,j+1);
            end
         else begin
              i:=0;
              repeat
              i:=i+1;
              until ((r[i] = '+')and(r[i-1] <> 'e')) or
                    ((r[i] = '-')and(i<>1)and(r[i-1]<>'e')) or
                    (i = length(r));
              r2:='';
              r3:='';
              j:=i-1;
              while not (((r[j] = '+')and(r[j-1]<>'e')) or
                        ((r[j] = '-')and(j<>1)and(r[j-1]<>'e')) or
                        (j = 0)) do
                    begin
                    j:=j-1;
                    end;
              k:=i+1;
              while not (((r[k] = '+')and(r[k-1]<>'e')) or
                    ((r[k] = '-')and(k<>i+1)and(r[k-1]<>'e')) or
                    (k = length(r)+1)) do
                    begin
                    k:=k+1;
                    end;
              r2:=PrevedDoNormalTvaru(copy(r,j+1,i-j-1),z);
              r3:=PrevedDoNormalTvaru(copy(r,i+1,k-i-1),z);
            if (KontrolaVelikosti(PrevedNaAx10n(r2,z),z) <> 0) or
               (KontrolaVelikosti(PrevedNaAx10n(r3,z),z) <> 0) then
               begin
               ErrCode:=1;
               r:='Error';
               break;
               end;
              case r[i] of
                   '+' : r2:=SectiPisemne(r2,r3,z);
                   '-' : r2:=OdectiPisemne(r2,r3,z);
                   end;
              if (KontrolaVelikosti(r2,z) <> 0) then
                 begin
                 ErrCode:=1;
                 r:='Error';
                 break;
                 end;
              r2:=PrevedNaAx10n(r2,z);
              delete(r,j+1,k-j-1);
              insert(PrevedNaAx10n(r2,z),r,j+1);
              end;
         end;
Vypocet:=r;
OdstranZpravu;
end;
procedure ArOperace(Typ:char);
function PrvniClen:integer;
          (*
          Najde prvni neprazdne textove pole
          hodnota tohoto pole je prvnim cislem
          *)
var i:integer;
begin
for i:=2 to 26 do
    begin
    if Txt[i].Obsah <> '' then
       begin
       PrvniClen:=i;
       break;
       end;
    if i = 26 then PrvniClen:=1;
    end;
end;
label 1,vypocti_v_desitkove;
var i,j,k,l,m:integer;
    Pom:Retezec;
    PoziceVysledku:integer;
begin
PoziceVysledku:=0;
if PrvniClen = 1 then
   begin
   ErrMessage(2,'Nebyla zadana cisla');
   goto 1;
   end;
Scitance[0]^:='0';
Scitance[1]^:='0';
Pom:='';
for j:=20 to 370 do
for i:=210 to 400 do
    WPutPixel(i,j,7);
for j:=370 to 399 do
for i:=1 to 639 do
    WPutPixel(i,j,7);
ZobrazZpravu('kontroluji');
if KontrolaRetezce(Txt[1].Obsah,Soustava) then
   begin
   for i:=2 to 26 do
       if not KontrolaRetezce(Txt[i].Obsah,Prevod) then
          begin
          OdstranZpravu;
          goto 1;
          end;
   OdstranZpravu;
   Aritmeticke_operace:=true;
   ZobrazZpravu('Pocitam');
   for l:= 215 to 219 do
   for m:= Zprava.X1+14 to Zprava.X1+64 do
       WPutPixel(m,l,15);
   for i:=w[1].x1 to w[1].x2 do
       Dispose(w[1].Obsah[i]);
   for i:=2 to 26 do
          Scitance[i]^:=PrevedDoNormalTvaru(Txt[i].Obsah,NaC(Txt[1].Obsah));
   Vypocti_v_desitkove:
   if PoziceVysledku = 1 then
      for i:=2 to 26 do
          Scitance[i]^:=PrevedDoNormalTvaru(Scitance[i]^,NaC(Txt[1].Obsah));
   case Typ of
        '-' : Scitance[PoziceVysledku]^:='Zacinam';
        '*' : Scitance[PoziceVysledku]^:='1';
        '/' : Scitance[PoziceVysledku]^:='Zacinam';
        end;
   for i:=2 to 26 do
       begin
     if Scitance[i]^ <> '' then
       begin
       case Typ of
            '+' : Scitance[PoziceVysledku]^:=SectiPisemne(Scitance[PoziceVysledku]^,Scitance[i]^,NaC(Txt[1].Obsah));
            '-' : begin
                  if Scitance[PoziceVysledku]^ = 'Zacinam' then
                     begin
                     Scitance[PoziceVysledku]^:=OdectiPisemne(Scitance[i]^,Scitance[i+1]^,NaC(Txt[1].Obsah));
                     i:=i+1;
                     end
                  else Scitance[PoziceVysledku]^:=OdectiPisemne(Scitance[PoziceVysledku]^,Scitance[i]^,NaC(Txt[1].Obsah));
                  end;
            '*' : begin
                  Scitance[PoziceVysledku]^:=NasobPisemne(Scitance[PoziceVysledku]^,Scitance[i]^,NaC(Txt[1].Obsah));
                  end;
            '/' : begin
                  if Scitance[PoziceVysledku]^ = 'Zacinam' then
                     begin
                     if (SeberNulyZepredu(SeberNuly(Scitance[i+1]^)) <> '')
                        or (Scitance[i+1]^ = '') then
                        begin
                        Scitance[PoziceVysledku]^:=DelPisemne(Scitance[i]^,Scitance[i+1]^,NaC(Txt[1].Obsah));
                        i:=i+1;
                        end
                     else begin
                          ErrMessage(2,'Nelze delit nulou');
                          for i:=w[1].x1 to w[1].x2 do
                              New(w[1].Obsah[i]);
                          goto 1;
                          end;
                     end
                  else if (SeberNulyZepredu(SeberNuly(Scitance[i]^)) <> '')
                       or (Scitance[i]^ = '') then
                       begin
                       Scitance[PoziceVysledku]^:=DelPisemne(Scitance[PoziceVysledku]^,Scitance[i]^,NaC(Txt[1].Obsah));
                       end
                     else begin
                          ErrMessage(2,'Nelze delit nulou');
                          for i:=w[1].x1 to w[1].x2 do
                              New(w[1].Obsah[i]);
                          goto 1;
                          end;
                  end;
            end;
            Scitance[PoziceVysledku]^:=PrevedNaAx10n(Scitance[PoziceVysledku]^,NaC(Txt[1].Obsah));
       if (KontrolaVelikosti(Scitance[PoziceVysledku]^,NaC(Txt[1].Obsah)) <> 0) then
          begin
          ErrMessage(2,'Pri vypoctu doslo k prekroceni hranic cisla');
          for i:=w[1].x1 to w[1].x2 do
              New(w[1].Obsah[i]);
          goto 1;
          end;
          Scitance[PoziceVysledku]^:=PrevedDoNormalTvaru(Scitance[PoziceVysledku]^,NaC(Txt[1].Obsah));
          end;
            WPutPixel(Zprava.X1+10+i*2-1,215,2);
            WPutPixel(Zprava.X1+10+i*2-1,216,2);
            WPutPixel(Zprava.X1+10+i*2-1,217,2);
            WPutPixel(Zprava.X1+10+i*2-1,218,2);
            WPutPixel(Zprava.X1+10+i*2-1,219,2);
            WPutPixel(Zprava.X1+10+i*2,215,2);
            WPutPixel(Zprava.X1+10+i*2,216,2);
            WPutPixel(Zprava.X1+10+i*2,217,2);
            WPutPixel(Zprava.X1+10+i*2,218,2);
            WPutPixel(Zprava.X1+10+i*2,219,2);
       end;
   Scitance[PoziceVysledku]^:=PrevedNaAx10n(Scitance[PoziceVysledku]^,NaC(Txt[1].Obsah));
   if (Txt[1].Obsah <> '10') or (PoziceVysledku = 1) then
      begin
      for i:=2 to 26 do
          if not (Scitance[i]^ = '') then
             begin
             Scitance[i]^:=PrevedDoNormalTvaru(Scitance[i]^,NaC(Txt[1].Obsah));
             PrevedDoSoustavy(Scitance[i]^,NaC(Txt[1].Obsah),10);
             Scitance[i]^:=PrevedNaAx10n(Scitance[i]^,10);
             end;
       if PoziceVysledku = 0 then
          begin
          Pom:=Txt[1].Obsah;
          Txt[1].Obsah:='10';
          PoziceVysledku:=1;
          goto vypocti_v_desitkove;
          end
      else begin
           Txt[1].Obsah:=Pom;
           WNastavBarvuTextu(14);
           OknoPisRetezec(1,'Vysledek: ',10,380);
           WNastavBarvuTextu(8);
           VypisVDesitkoveSoustave(Scitance);
           end;
      end
   else begin
        WNastavBarvuTextu(14);
        WNastavBarvuPozadi(7);
        OknoPisRetezec(1,'                                ',10,380);
        OknoPisRetezec(1,'Vysledek: ',10,380);
        WNastavBarvuTextu(8);
        OknoPisRetezec(1,Scitance[0]^,100,380);
        end;
   OdstranZpravu;
   Aritmeticke_operace:=false;
   for i:=w[1].x1 to w[1].x2 do
       New(w[1].Obsah[i]);
   end;
1:
Aritmeticke_Operace:=false;
end;
procedure CreateMenu;
begin
OknoOtevri(1,1,640,400,'Ciselne pozicni soustavy v1.4',1);
ButonVytvor(1,300,100,'Prevody',1);
ButonVytvor(1,300,120,'Aritmeticke operace',2);
ButonVytvor(1,300,140,'Vypocet vyrazu',3);
ButonVytvor(1,300,160,'Napoveda',4);
ButonVytvor(1,300,180,'Konec',5);
ClrKlBuffer;
end;
begin
end.