unit mouse;
(*
Tato jednotka zajistuje ovladani mysi a nekolik dalsich veci.
Zakladni procedury jsem prevzal z knihy Jak na to v Pascalu a
prepsal do Assembleru
*)
interface
uses dos,lib1,crt,windws;
var r:registers;
    MouseCursor : array [1..16,1..16] of 0..15;
    (* jak bude vypadak kurzor mysi*)
function MouseInit:integer;
(* inicializuje mys a vrati pocet tlacitek *)
procedure MouseVisible;
(* pry zviditelni mys ( nefunkcni v graf. modu meho programu *)
procedure MouseInVisible;
(* pry zneviditelni mys (nefunkcni v graf. modu meho programu *)
function GetMouseX:word;
(* Vrati horizontalni souradnici mysi *)
function GetMouseY:word;
(* Vrati vertikalni souradnici mysi *)
procedure MouseMove;
(* zajistuje, aby se z mysi dalo pohybovat (pokud je volana v cyklu) *)
procedure SetMouseSensitivity(Per8Pixels:word);
(* Nastav, kolik krok udl kurzor mysi na 8 pixel*)
procedure MouseStav(var Buton,Horiz,Vert:word);
(* Zjisti stav tlacitek mysi a kde byla stisknuta *)
function MouseClickOnButon(IDOkna:integer;b:TypButon):boolean;
(*
zjisti, zda uzivatel neklikl na nejake tlacitko, pokud je tomu tak,
udela efekt zmacknuti tlacitka
*)
function MouseClickOnTxtPole(IDOKna:integer; Index:integer):boolean;
(*
Zjisti, zda uzivatel neklikl na nejake textove pole. Polud klikl,
umozni mu do pole psat. Psani lze ukoncit stiskem Enteru, nebo
kliknutim mimo textove pole
*)
procedure ClrTxtPole(IDOkna:integer; Index:integer);
(*
Vyprazdni textove pole (deje se tak pred kazdym novym zapisem do pole)
*)
procedure SetMouseRange(x1,y1,x2,y2:word);
(* Nastavi rozsah pohybu mysi *)
procedure PisDoTextPole(IDOkna:integer; Index:integer);
(* Zajistuje psani do textoveho pole, pred zacatkem psani jej vymaze *)
implementation
function MouseInit:integer; assembler;
asm
xor ax, ax
int 33h
mov aL, bl
end;
procedure MouseVisible; assembler;
asm
mov ax, 1
int 33h
end;
procedure MouseInvisible; assembler;
asm
mov ax, 2
int 33h
end;
var Pozice:word;
function GetMouseX:word; assembler;
asm
mov ax ,3h
int 33h
mov ax , cx
end;
function GetMouseY:word; assembler;
asm
mov ax ,3h
int 33h
mov ax, dx
end;
procedure MouseMove;
var MX,MY,i,j:integer;
    x:array [1..16,1..16] of 0..15;
begin
MX:=GetMouseX;
MY:=GetMouseY;
   for j:=1 to 16 do
   for i:=1 to 16 do
       x[i,j]:=WGetPixel(MX+i-1,MY+j-1);
   for j:=1 to 16 do
   for i:=1 to 16 do
       begin
       if (MouseCursor[i,j] = 0) then
          WPutPixel(MX+i-1,MY+j-1,x[i,j])
       else WPutPixel(MX+i-1,MY+j-1,MouseCursor[i,j]);
       end;
   delay(25);
   for j:=1 to 16 do
   for i:=1 to 16 do
       WPutPixel(MX+i-1,MY+j-1,x[i,j]);
end;
procedure SetMouseSensitivity(Per8Pixels:word);
begin
r.ax:=$15;
r.cx:=Per8Pixels;
r.dx:=Per8Pixels;
intr($51,r);
end;
procedure MouseStav(var buton,horiz,vert:word);
begin
r.ax:=3;
intr($33,r);
buton:=r.bx;
Horiz:=r.cx;
Vert:=r.dx;
end;
function MouseClickOnButon(IDOkna:integer; b:TypButon):boolean;
label 1;
var i,j:integer;
    but,x,y,Barva:word;
begin
MouseStav(but,x,y);
x:=GetMouseX;
y:=GetMouseY;
if (x>=w[IDOkna].x1+b.x1) and (x<=w[IDOkna].x1+b.x2) and
   (y>=w[IDOkna].y1+b.y1) and (y<=w[IDOkna].y1+b.y2) and
   (w[IDOkna].Stav = Open) and
   (but and 1>0) then
   begin
   Barva:=WGetPixel(w[IDOkna].x1+b.x1-1,w[IDOKna].y1+b.y1);
   for i:=b.y1 to b.y2 do
       begin
       WPutPixel(w[IDOkna].x1+b.x1-1,w[IDOkna].y1+i,8);
       WPutPixel(w[IDOkna].x1+b.x2+1,w[IDOkna].y1+i,8);
       end;
   for i:=b.x1 to b.x2 do
       begin
       WPutPixel(w[IDOkna].x1+i,w[IDOkna].y1+b.y1-1,8);
       WPutPixel(w[IDOkna].x1+i,w[IDOkna].y1+b.y2+1,8);
       end;
   delay(100);
   repeat
   MouseMove;
   MouseStav(but,x,y);
   until (but and 1 = 0) or not ((x>=w[IDOkna].x1+b.x1) and
         (x<=w[IDOkna].x1+b.x2)) or
         not ((y>=w[IDOkna].y1+b.y1) and (y<=w[IDOkna].y1+b.y2));
   for i:=b.y1 to b.y2 do
       begin
       WPutPixel(w[IDOkna].x1+b.x1-1,w[IDOkna].y1+i,Barva);
       WPutPixel(w[IDOkna].x1+b.x2+1,w[IDOkna].y1+i,Barva);
       end;
   for i:=b.x1 to b.x2 do
       begin
       WPutPixel(w[IDOkna].x1+i,w[IDOkna].y1+b.y1-1,Barva);
       WPutPixel(w[IDOkna].x1+i,w[IDOkna].y1+b.y2+1,Barva);
       end;
   if not ((x>w[IDOkna].x1+b.x1) and (x<w[IDOkna].x1+b.x2)) or
      not ((y>w[IDOkna].y1+b.y1) and (y<w[IDOkna].y1+b.y2)) then
      goto 1;
   MouseClickOnButon:=true;
   end
else begin
     1:
     MouseClickOnButon:=false;
     end;
end;
function MouseTlLeve:boolean;
var b,x,y:word;
begin
MouseStav(b,x,y);
if (b and 1>0) then MouseTlLeve:=true
else MouseTlLeve:=false;
end;
procedure ClrTxtPole(IDOkna:integer; Index:integer);
var i,j:integer;
begin
for j:=w[IDOkna].y1+Txt[Index].y1 to w[IDOkna].y1+Txt[Index].y2-1 do
for i:=w[IDOkna].x1+Txt[Index].x1 to w[IDOkna].x1+Txt[Index].x2-1 do
    WPutPixel(i,j,15);
end;
var PriznakEnteru:boolean;
    PisX,Kl,i,j:integer;
    Cursor: array [1..8] of byte;
procedure CursorOff(IDOkna,Index,PisX:integer);
begin
for i:=1 to 8 do
    WPutPixel(w[IDOkna].x1+Txt[Index].x1+PisX+1,
    w[IDOkna].y1+Txt[Index].y1-2+i,Cursor[i]);
end;
procedure CursorOn(IDOkna,Index,PisX:integer);
begin
for i:=1 to 8 do
    begin
    Cursor[i]:=WGetPixel(w[IDOkna].x1+Txt[Index].x1+PisX+1,
    w[IDOkna].y1+Txt[Index].y1-2+i);
    WPutPixel(w[IDOkna].x1+Txt[Index].x1+PisX+1,
    w[IDOkna].y1+Txt[Index].y1-2+i,0);
    end;
end;
procedure PisDoTextPole(IDOkna:integer; Index:integer);
var Pocet:integer;
begin
Pocet:=0;
PriznakEnteru:=false;
PisX:=8*length(Txt[Index].Obsah);
while keypressed do readkey;
WNastavBarvuPozadi(15);
WNastavBarvuTextu(0);
CursorOn(IDOkna,Index,PisX);
repeat
Kl:=0;
if keypressed then Kl:=readkey2;
MouseMove;
case Kl of
     40..122,
     ord(':'),
     ord('\') : begin
                if length(Txt[Index].Obsah)<Txt[Index].Delka then
                   begin
                   CursorOff(IDOkna,Index,PisX);
                   Inc(PisX,8);
                   insert(chr(Kl),Txt[Index].Obsah,PisX div 8);
                   ClrTxtPole(IDOkna,Index);
                   WNastavBarvuTextu(8);
                   OknoPisRetezec(IDOkna,Txt[Index].Obsah,Txt[Index].x1,Txt[Index].y1-1);
                   CursorOn(IDOkna,Index,PisX);
                   end;
                end;
         8  : begin
              if not (PisX = 0) then
                 begin
                 CursorOff(IDOkna,Index,PisX);
                 delete(Txt[Index].Obsah,PisX div 8,1);
                 ClrTxtPole(IDOkna,Index);
                 WNastavBarvuTextu(8);
                 OknoPisRetezec(IDOkna,Txt[Index].Obsah,Txt[Index].x1,
                                Txt[Index].y1-1);
                 Dec(PisX,8);
                 CursorOn(IDOkna,Index,PisX);
                 end;
              end;
         ord('K')+256 : begin           (* Kurzor Doleva *)
                        if PisX>0 then
                           begin
                           CursorOff(IDOkna,Index,PisX);
                           Dec(PisX,8);
                           CursorOn(IDOkna,Index,PisX);
                           end;
                        end;
         ord('M')+256 : begin           (* Kurzor Doprava *)
                        if PisX<8*length(Txt[Index].Obsah)
                           then begin
                                CursorOff(IDOkna,Index,PisX);
                                Inc(PisX,8);
                                CursorOn(IDOkna,Index,PisX);
                                end;
                        end;
     end;
Inc(Pocet);
until (MouseTlLeve) or (Kl = 13) or (Kl = 27);
if (Kl = 13) or
   (Kl = 27) then PriznakEnteru:=true;
WNastavBarvuPozadi(7);
WNastavBarvuTextu(8);
CursorOff(IDOkna,Index,PisX);
end;
function MouseClickOnTxtPole(IDOkna:integer; Index:integer):boolean;
label 1;
var i,j:integer;
    but,x,y:word;
begin
PriznakEnteru:=false;
MouseStav(but,x,y);
if (x>=w[IDOkna].x1+Txt[Index].x1) and (x<=w[IDOkna].x1+Txt[Index].x2) and
   (y>=w[IDOkna].y1+Txt[Index].y1) and (y<=w[IDOkna].y1+Txt[Index].y2) and
   (but and 1>0) and (w[IDOkna].Stav = Open) then
   begin
   for i:=Txt[Index].x1 to Txt[Index].x2 do
       begin
       WPutPixel(i+w[IDOkna].x1-1,Txt[Index].y1-1+w[IDOkna].y1,12);
       WPutPixel(i+w[IDOkna].x1-1,Txt[Index].y2+w[IDOkna].y1,12);
       end;
   for i:=Txt[Index].y1 to Txt[Index].y2 do
       begin
       WPutPixel(Txt[Index].x1-1+w[IDOkna].x1,i+w[IDOkna].y1-1,12);
       WPutPixel(Txt[Index].x2+w[IDOkna].x1,i+w[IDOkna].y1-1,12);
       end;
   WPutPixel(Txt[Index].x2+w[IDOkna].x1,Txt[Index].y2+w[IDOkna].y1,12);
   repeat
   MouseMove;
   PisDoTextPole(IDOkna,Index);
   MouseStav(but,x,y);
   until (but and 1 > 0) and
         (not ((x>=Txt[Index].x1) and
         (x<=Txt[Index].x2)) or
         not ((y>=Txt[Index].y1) and
         (y<=Txt[Index].y2))) or (PriznakEnteru);
   MouseClickOnTxtPole:=true;
   for i:=Txt[Index].x1 to Txt[Index].x2 do
       begin
       WPutPixel(i+w[IDOkna].x1-1,Txt[Index].y1-1+w[IDOkna].y1,7);
       WPutPixel(i+w[IDOkna].x1-1,Txt[Index].y2+w[IDOkna].y1,7);
       end;
   for i:=Txt[Index].y1 to Txt[Index].y2 do
       begin
       WPutPixel(Txt[Index].x1-1+w[IDOkna].x1,i+w[IDOkna].y1-1,7);
       WPutPixel(Txt[Index].x2+w[IDOkna].x1,i+w[IDOkna].y1-1,7);
       end;
   WPutPixel(Txt[Index].x2+w[IDOkna].x1,Txt[Index].y2+w[IDOkna].y1,7);
   end
else begin
     MouseClickOnTxtPole:=false;
     end;
end;
procedure SetMouseRange(x1,y1,x2,y2:word);
begin
r.ax:=7;
r.cx:=x1;
r.dx:=x2;
intr($33,r);
r.ax:=8;
r.cx:=y1;
r.dx:=y2;
intr($33,r);
end;
var s:text;
    zn:char;
begin
assign(s,'mouse.dat');
reset(s);
i:=1;
j:=1;
while not eof(s) do
      begin
      while not eoln(s) do
            begin
            read(s,zn);
            case zn of
                 '0'..'9'   : MouseCursor[i,j]:=ord(zn)-48;
                 'A'..'F'   : MouseCursor[i,j]:=ord(zn)-55;
                 end;
            i:=i+1;
            end;
      readln(s);
      j:=j+1;
      i:=1;
      end;
close(s);
end.