unit windws;
(*
Tato jednotka zajistuje veskery design meho programu.
Nepouziva standartni jednotky Graph (jenom aby nacetla
znaky abecedy) a to kvuli pomalosti jednotky Graph.
Procedury, ktere jsou napsane v Assembleru, nejsou moje vlastni
- vyhledal jsem je na Internetu
*)
interface
{$G+,N+}
uses lib1;
const OknoPozadi = 7;
      OknoText = 0;
      OknoPozadiVrsek = 1;
      OknoTextVrsek = 15;
      Mody:Array[0..7] of Word = ($12E,$131,$141,$151,$100,$101,$103,$105);
      (* Cisla jednotlivych grafickych modu *)
      Sirka:Array[0..7] of Word = (320,320,400,512,640,640,800,1024);
      (*Sirka obrazovky v pixelech u jednotlivych grafickych modu *)
      M320x200 = 0;
      M320x240 = 1;
      M400x300 = 2;
      M512x384 = 3;         (* konstanty pro graf. mody *)
      M640x400 = 4;
      M640x480 = 5;
      M800x600 = 6;
      M1024x768 = 7;
      VideoAddr = $A000;
type  OknoData = array [1..400] of 0..15;  (* Sem se uklada vzhled okna *)
      TypAnoNe = (Ano,Ne);
      St = (Closed,Open,Invisible);
      TypButon = record              (* tlacitko *)
                 X1,Y1,X2,Y2,Index:integer; (* pozice vzhledem k oknu *)
                 end;
      TextovePole = record                 (* Textove pole *)
                  X1,Y1,X2,Y2:integer;     (* Pozice vzhledem k oknu *)
                  Delka:byte; {Kolik znaku lze do text pole napsat}
                  Obsah:Retezec;    (* Co je v text. poli? *)
                  end;
      Okno = record                  (*Okno *)
             X1,Y1,X2,Y2:integer;     (* Pozice *)
             Stav:St;                 (* aktualni stav okna *)
             Obsah:array [1..640] of ^OknoData;   (* vzhled okna *)
             Nazev:Retezec;         (* Nazev okna *)
             Index:integer;         (* cislo okna *)
             Butony: set of 0..10;  (* cisla tlacitek, ktera jsou v okne *)
             TxtPole:set of 1..40;  (* cisla txt. poli v okne *)
             ClosingButon:TypButon; (* Zaviraci tlacitko okna *)
             end;
      AlphaBet = array [32..255,1..8,1..8] of 0..1;
      (*Tady jsou ulozeny znaky ceske abecedy *)
var Pismena:Alphabet;
    b: array [0..50] of TypButon;        (* tlacitka *)
    Txt: array [0..50] of TextovePole;   (* okna *)
    w:array [1..10] of Okno;
    Zprava: record
            Stav:boolean;            (* Znaci, je-li ted zobrazena nejaka zprava *)
            Okno:integer;            (* Znaci, ktere okno zprava prekryva *)
            X1,X2:integer;           (* X-ove souradnice zpravy *)
            end;
    PisX,PisY:integer;           (* pozice kurzoru *)
    BarvaTextu,BarvaPozadi:byte; (* barvy textu a pozadi *)
    Aritmeticke_operace:boolean; (*
                                   pro ErrMessage. Kdyz se provadi ar.
                                   operace, nesmi se zrusit pole ukazatelu
                                   *)
function WInitGraph(mode:word):boolean;
(*  Inicializace grafiky (lze pouzit od 320x200 do 1024x768) *)
procedure WNaText;
(* Prepne do textoveho rezimu *)
procedure WPutpixel(X,Y:word; Barva:byte);
(* Vykresli bod *)
function WGetPixel(x,y:word):byte;
(* Zjisti barvu bodu na pozici x y *)
procedure WOutText(Text:Retezec);
(* Vypise text *)
procedure WMoveTo(x,y:integer);
(* Ukazatel textu se presune na pozici x y *)
procedure WNastavBarvuTextu(Barva:byte);
(* Nastavy barvu textu *)
procedure WNastavBarvuPozadi(Barva:byte);
(* Nastavy barvu pozadi *)
procedure ZobrazZpravu(Text:Retezec);
(* Zobrazi zpravu (nelze odklepnout, zmizi pri odstran zpravu *)
procedure OdstranZpravu;
(* Odstrani zpravu *)
procedure OknoUloz(IDOkna:integer; x1,y1,x2,y2:integer);
(* Ulozi okno *)
procedure OknoPisCislo(IDOkna:integer; var Cislo; x,y:integer);
(*Napise cislo, pozice je udavana vzhledem k oknu IDOkna *)
procedure OknoPisRetezec(IDOkna:integer; Text:Retezec; x,y:integer);
(*Napise retezec, pozice je udavana vzhledem k oknu IDOkna *)
procedure OknoOtevri(x1,y1,x2,y2:integer; Nazev:Retezec; IDOkna:integer);
(*
Vytvori okno. x1 a y1 udavaji levy horni roh, x2 a y2 pravy.
Nazev je retezec, ktery se napise doleva nahoru do okna
IDOkna je cislo okna
*)
procedure OknoZavri(IDOkna:integer);
(* Zavre okno *)
procedure OknoPisSoubor(IDOkna:integer; JmenoSouboru:Retezec; x,y:integer);
(* Vypise do okna textovy soubor *)
procedure TxtPoleVytvor(IDOkna:integer; x1,y1,x2,y2:integer; Delka:byte; Index:integer);
(* Vytvori v okne textove pole *)
procedure AktualizujTxtPole(IDOkna,Index:integer);
(* Vypise do textoveho pole Index jeho obsah *)
procedure TxtPoleZrus(IDOKna:integer; Index:integer);
(* Zrusi v okne textove pole *)
procedure ButonVytvor(IDOkna:integer; x,y:word; Text:string; Index:integer);
(* Vytvori tlacitko *)
procedure ButonZrus(IDOkna:integer; Index:integer);
(* Zrusi tlacitko *)

procedure ErrMessage(IDOkna:integer; Text:Retezec);
(*
Zajisti vznik chyboveho hlaseni, tj. vytvori okno s nazvem "Chyba" s
tlacitkem "OK". Okno Zavrit kliknutim na "OK" nebo Enterem
*)
function AnoNeOtazka(IDOkna:integer; Text:Retezec):TypAnoNe;
(*
Vytvori okno, ktere lze ukoncit jen pomoci tlac. ANO a NE
*)
implementation
uses mouse,crt;
Var Banka :Word;
SirkaOkna :Word;
I,J :Word;
procedure Barva(CisloBarvy:byte; R,G,B:byte);
begin
Port[$3c8]:=CisloBarvy;
Port[$3c9]:=R;
Port[$3c9]:=G;
Port[$3c9]:=B;
end;
Function WInitGraph(Mode:Word):Boolean;
begin
Asm
MOV BX,[Mode]
SHL BX,1
MOV AX,WORD [Sirka[BX]]
MOV SirkaOkna,AX
MOV BX,WORD [Mody[BX]]
MOV AX,4F02h {Nastav video mod}
INT 10h
CMP AX,004Fh
JNE @Chyba
MOV AL,True
JMP @Konec
@Chyba:
MOV AL,False
@Konec:
MOV Banka,0
End;
Barva(1,0,31,63);
Barva(2,0,0,32);
end;
Procedure WPutPixel(X,Y:Word;Barva:Byte); Assembler;
ASM
MOV DI,VideoAddr
MOV ES,DI
MOV AX,[Y]
MUL SirkaOkna
ADD AX,[X]
JNC @Nepretekl
INC DX
@Nepretekl:
MOV DI,AX
CMP DX,Banka
JE @Ok
MOV Banka,DX
MOV AX,4F05h {Rizeni videopameti CPU}
XOR BX,BX
INT 10h
@Ok:
MOV AL,[Barva]
STOSB
End;
Function WGetPixel(X,Y:Word):Byte; Assembler;
ASM
MOV DI,VideoAddr
MOV ES,DI
MOV AX,[Y]
MUL SirkaOkna
ADD AX,[X]
JNC @Nepretekl
INC DX
@Nepretekl:
MOV DI,AX
CMP DX,Banka
JE @Ok
MOV Banka,DX
MOV AX,4F05h {Rizeni videopameti CPU}
XOR BX,BX
INT 10h
@Ok:
MOV AL,ES:[DI]
End;
procedure WNaText; assembler;
asm
   mov ax, 03h;
   int 10h;
   mov ax, 01h;
   int 33h;
   mov ax, 00h;
   int 33h;
end;
procedure WOutText(Text:Retezec);
var i,j,k:integer;
begin
for k:=1 to length(Text) do
    begin
    for j:=1 to 8 do
        begin
        for i:=1 to 8 do
            begin
            if Pismena[ord(Text[k]),i,j] = 1 then
               WPutPixel(PisX+i+k*8-8,PisY+j,BarvaTextu)
            else WPutPixel(PisX+i+k*8-8,PisY+j,BarvaPozadi);
            end;
        end;
    end;
   PisX:=PisX+8;
end;
procedure WNastavBarvuPozadi(Barva:byte);
begin
BarvaPozadi:=Barva;
end;
procedure WNastavBarvuTextu(Barva:byte);
begin
BarvaTextu:=Barva;
end;
procedure WMoveTo(x,y:integer);
begin
PisX:=x;
PisY:=y;
end;
procedure UlozPozadi(IDOkna:integer; x1,y1,x2,y2:integer);
var i,j:integer;
    s:SouborTextovy;
    zn:char;
begin
assign(s,NaR(w[IDOkna].Index)+'b.dat');
rewrite(s);
for j:=y1 to y2 do
    begin
    for i:=x1 to x2 do
        begin
        zn:=chr(WGetPixel(i,j));
        write(s,zn);
        end;
    writeln(s);
    end;
close(s);
end;
procedure ButonVytvor(IDOKna:integer; x,y:word; Text:string; Index:integer);
var ButonX2:word;
    BudonY2:word;
    i,j:integer;
begin
b[Index].Index:=w[IDOkna].Index;
ButonX2:=x+8*(length(Text))+4;
b[Index].x1:=x;
b[Index].y1:=y;
b[Index].x2:=ButonX2;
b[Index].y2:=y+14;
if (w[IDOkna].Stav = Open) and (ButonX2+w[IDOkna].x1-1<w[IDOkna].x2) and
   (y<w[IDOkna].y2-w[IDOkna].y1) then
   begin
   w[IDOkna].Butony:=w[IDOkna].Butony+[Index];
   for j:=y to y+14 do
   for i:=x to ButonX2 do
       begin
       if (i = x) or (i = ButonX2) or (j = y) or (j = y+14) then
          begin
          WPutPixel(i+w[IDOkna].x1,j+w[IDOkna].y1,8);
          end
       else WPutPixel(i+w[IDOkna].x1,j+w[IDOkna].y1,7);
       end;
   WMoveTo(w[IDOkna].x1+x+3,w[IDOkna].y1+y+3);
   BarvaPozadi:=7;
   BarvaTextu:=0;
   WOutText(Text);
   OknoUloz(IDOkna,w[IDOkna].x1+b[Index].x1,b[Index].y1+w[IDOkna].y1,
   b[Index].x2+w[IDOkna].x1,w[IDOkna].y1+b[Index].y2);
   end;
end;
procedure ButonZrus(IDOkna:integer; Index:integer);
var i,j:integer;
    BarvaPozadi:byte;
begin
if w[IDOkna].Stav = Open then
   begin
   if Index = 0 then BarvaPozadi:=1
   else BarvaPozadi:=7;
   for j:=b[Index].y1 to b[Index].y2 do
   for i:=b[Index].x1 to b[Index].x2 do
       WPutPixel(i+w[IDOkna].x1,j+w[IDOkna].y1,BarvaPozadi);
   w[IDOkna].Butony:=w[IDOkna].Butony-[Index];
   OknoUloz(IDOkna,w[IDOkna].x1+b[Index].x1,w[IDOkna].y1+b[Index].y1,
   w[IDOkna].x1+b[Index].x2,w[IDOkna].y1+b[Index].y2);
   b[Index].x1:=0-1;
   b[Index].x2:=0-1;
   b[Index].y1:=0-1;
   b[Index].y2:=0-1;
   end;
end;
procedure OknoOtevri(x1,y1,x2,y2:integer; Nazev:Retezec; IDOkna:integer);
var i,j:integer;
begin
if w[IDOkna].Stav = Open then
   begin
   for i:=w[IDOkna].x1 to w[IDOkna].x2 do
       Dispose(w[IDOkna].Obsah[i]);
   for i:=x1 to x2 do
       New(w[IDOkna].Obsah[i]);
   end;
if (w[IDOkna].Stav = Closed) then
    for i:=x1 to x2 do
        New(w[IDOkna].Obsah[i]);
w[IDOkna].Index:=IDOkna;
w[IDOkna].Nazev:=Nazev;
w[IDOkna].Butony:=[0];
w[IDOkna].TxtPole:=[];
w[IDOkna].X1:=x1;
w[IDOkna].y1:=y1;
w[IDOkna].y2:=y2;
w[IDOkna].x2:=x2;
if (w[IDOkna].Stav = Closed) then UlozPozadi(IDOkna,x1,y1,x2,y2);
w[IDOkna].Stav:=Open;
for j:=y1 to y2 do
for i:=x1 to x2 do
    begin
    if j<=y1+16 then
       WPutPixel(i,j,OknoPozadiVrsek)
    else if (i = x1) or (i = x2) or (j = y2) then
            WPutPixel(i,j,8)
    else WPutPixel(i,j,OknoPozadi);
    end;
ButonVytvor(IDOkna,w[IDOkna].x2-15-w[IDOkna].x1,1,'x',0);
WMoveTo(x1+2,y1+2);
WNastavBarvuPozadi(1);
WNastavBarvuTextu(15);
WOutText(Nazev);
WMoveTo(x1+2,y1+12);
OknoUloz(IDOkna,x1,y1,x2,y2);
end;
procedure OknoZavri(IDOkna:integer);
var i,j:integer;
    s:SouborTextovy;
    s2:SouborZnaku;
    zn:char;
begin
if w[IDOkna].Stav = Open then
   begin
   assign(s,NaR(w[IDOkna].Index)+'b.dat');
   reset(s);
   for j:=w[IDOkna].y1 to w[IDOkna].y2 do
       begin
       for i:=w[IDOkna].x1 to w[IDOkna].x2 do
           begin
           read(s,zn);
           w[IDOkna].Obsah[i]^[j]:=ord(zn);
           end;
       readln(s);
       end;
   w[IDOkna].Stav:=Closed;
   close(s);
   for j:=w[IDOkna].y1 to w[IDOkna].y2 do
   for i:=w[IDOkna].x1 to w[IDOkna].x2 do
       WPutPixel(i,j,w[IDOkna].Obsah[i]^[j]);
   for i:=w[IDOkna].X1 to w[IDOkna].X2 do
          Dispose(w[IDOkna].Obsah[i]);
   end;
end;
procedure OknoUloz(IDOkna:integer; x1,y1,x2,y2:integer);
var i,j:integer;
begin
for j:=w[IDOkna].y1+y1-1 to w[IDOkna].y1+y2-1 do
for i:=w[IDOkna].x1+x1-1 to w[IDOkna].x1+x2-1 do
    w[IDOkna].Obsah[i]^[j]:=WGetPixel(i,j);
end;
procedure TxtPoleVytvor(IDOKna:integer;
          x1,y1,x2,y2:integer; Delka:byte; Index:integer);
var i,j:integer;
begin
if (w[IDOkna].Stav = Open) then
   begin
   w[IDOkna].TxtPole:=w[IDOkna].TxtPole+[Index];
   Txt[Index].Delka:=Delka;
   Txt[Index].X1:=x1;
   Txt[Index].X2:=x2;
   Txt[Index].Y1:=y1;
   Txt[Index].Y2:=y2;
   Txt[Index].Obsah:='';
   ClrTxtPole(IDOkna,Index);
   for i:=w[IDOkna].x1+x1 to x2 do
   for j:=w[IDOkna].y1+y1 to y2 do
       WPutPixel(i,j,15);
   OknoUloz(IDOkna,w[IDOkna].x1+x1,w[IDOkna].y1+y1,w[IDOkna].x1+x2,w[IDOkna].y1+y2);
   end;
end;
procedure TxtPoleZrus(IDOKna:integer; Index:integer);
begin
if w[IDOkna].Stav = Open then
   begin
   for i:=w[IDOkna].x1+Txt[Index].x1-1 to Txt[Index].x2 do
   for j:=w[IDOkna].y1+Txt[Index].y1-1 to Txt[Index].y2 do
       WPutPixel(i,j,7);
   w[IDOkna].TxtPole:=w[IDOkna].TxtPole-[Index];
   Txt[Index].X1:=0-1;
   Txt[Index].X2:=0-1;
   Txt[Index].Y1:=0-1;
   Txt[Index].Y2:=0-1;
   OknoUloz(IDOKna,w[IDOkna].x1+b[Index].x1,
   w[IDOkna].y1+b[Index].y1,w[IDOkna].x1+b[Index].x2,
   w[IDOkna].y1+b[Index].y2);
   end;
end;
procedure OknoPisCislo(IDOkna:integer; var Cislo; x,y:integer);
var r:Retezec;
begin
r:=NaR(longint(Cislo));
WMoveTo(w[IDOkna].x1+x,w[IDOkna].y1+y);
WOutText(r);
end;
procedure OknoPisSoubor(IDOkna:integer; JmenoSouboru:Retezec; x,y:integer);
var s:SouborTextovy;
    r:Retezec;
    Radek:integer;
begin
Radek:=0;
WNastavBarvuPozadi(7);
WNastavBarvuTextu(0);
assign(s,JmenoSouboru);
reset(s);
while not eof(s) do
      begin
      readln(s,r);
      OknoPisRetezec(IDOkna,r,x,y+Radek);
      Radek:=Radek+8;
      end;
close(s);
end;
procedure OknoPisRetezec(IDOKna:integer; Text:Retezec; x,y:integer);
begin
WMoveTo(w[IDOkna].x1+x,w[IDOkna].y1+y);
WOutText(Text);
PisX:=PisX+length(Text)*8;
end;
procedure NactiFont;
label konec_radku;
var i,j,k,l:integer;
    s:text;
    zn:char;
begin
assign(s,'font.dat');
reset(s);
for i:=32 to 255 do
    begin
    for k:=1 to 8 do
    for j:=1 to 8 do
        begin
        konec_radku:
        read(s,zn);
        case ord(zn) of
             0:  Pismena[i,j,k]:=0;
             15: Pismena[i,j,k]:=1;
             else goto konec_radku;
             end;
        end;
for l:=1 to 10 do
    WPutPixel(i+68,l+100,12);
    end;
close(s);
end;
procedure OknoZneviditelni(IDOkna:integer);
begin
w[IDOkna].Stav:=Invisible;
end;
function OknoOtevreno:integer;
var i:integer;
begin
for i:=1 to 10 do
    if w[i].Stav = Open then OknoOtevreno:=i;
end;
procedure ZobrazZpravu(Text:Retezec);
var j:integer;
begin
if Zprava.Stav then OdstranZpravu;
if not (Aritmeticke_operace) then
for j:=320-10-4*length(Text) to 320+10+4*length(Text) do
    begin
    Dispose(w[OknoOtevreno].Obsah[j]);
    end;
Zprava.X1:=320-10-4*length(Text);
Zprava.x2:=320+10+4*length(Text);
Zprava.Stav:=true;
Zprava.Okno:=OknoOtevreno;
OknoOtevri(320-10-4*length(Text),170,320+10+4*length(Text),230,' ',2);
ButonZrus(2,0);
WNastavBarvuPozadi(7);
WNastavBarvuTextu(8);
OknoPisRetezec(2,Text,10,26);
end;
procedure AktualizujTxtPole(IDOkna,Index:integer);
begin
ClrTxtPole(IDOkna,Index);
if length(Txt[Index].Obsah)<=Txt[Index].Delka then
   begin
   WNastavBarvuTextu(8);
   WNastavBarvuPozadi(15);
   OknoPisRetezec(IDOkna,Txt[Index].Obsah,Txt[Index].x1,Txt[Index].y1-1);
   WNastavBarvuPozadi(7);
   end
else Txt[Index].Obsah:='';
end;
procedure OdstranZpravu;
var j:integer;
begin
if Zprava.Stav then
   begin
   Zprava.Stav:=false;
   OknoZavri(2);
   if not (Aritmeticke_operace) then
   for j:=Zprava.X1 to Zprava.X2 do
       begin
       New(w[Zprava.Okno].Obsah[j]);
       end;
   OknoUloz(Zprava.Okno,Zprava.X1,170,Zprava.X2,230);
   ButonVytvor(Zprava.Okno,w[Zprava.Okno].x2-15-w[Zprava.Okno].x1,1,'x',0);
   end;
end;
procedure ErrMessage(IDOKna:integer; Text:Retezec);
var i,Kl,j,ErrCode:integer;
    s:SouborTextovy;
    Text2:Retezec;
begin
ErrCode:=0;
while keypressed do readkey;
if Zprava.Stav then
   OdstranZpravu;
assign(s,'Errors.dat');
reset(s);
while not eof(s) do
      begin
      readln(s,Text2);
      inc(ErrCode);
      if Text2 = Text then break;
      end;
i:=OknoOtevreno;
close(s);
OknoZneviditelni(i);
if not (Aritmeticke_operace) then
for j:=320-10-4*length(Text) to 320+10+4*length(Text) do
    begin
    Dispose(w[i].Obsah[j]);
    end;
OknoOtevri(320-10-4*length(Text),170,320+10+4*length(Text),230,'Chyba '+NaR(ErrCode),IDOkna);
WNastavBarvuPozadi(7);
WNastavBarvuTextu(0);
OknoPisRetezec(IDOKna,Text,10,26);
ButonVytvor(IDOkna,10+4*length(Text),42,'OK',6);
repeat
MouseMove;
if keypressed then Kl:=ord(readkey);
until (MouseClickOnButon(IDOkna,b[6])) or
      (Kl = 13) or (Kl = 27) or
      (MouseClickOnButon(IDOKna,b[0]));
ButonZrus(IDOkna,6);
ButonZrus(IDOkna,0);
OknoZavri(IDOkna);
w[i].Stav := Open;
if not aritmeticke_operace then
   for j:=w[IDOkna].x1 to w[IDOkna].x2 do
       New(w[i].Obsah[j]);
OknoUloz(i,320-10-4*length(Text),170,320+10+4*length(Text),230);
ButonVytvor(i,w[i].x2-15-w[i].x1,1,'x',0);
end;
function AnoNeOtazka(IDOKna:integer; Text:Retezec):TypAnoNe;
var i,Kl,j:integer;
    konec:boolean;
begin
while keypressed do readkey;
i:=OknoOtevreno;
OknoZneviditelni(i);
for j:=320-10-4*length(Text) to 320+10+4*length(Text) do
    begin
    Dispose(w[i].Obsah[j]);
    end;
OknoOtevri(320-10-4*length(Text),170,320+10+4*length(Text),230,'?',IDOkna);
WNastavBarvuPozadi(7);
WNastavBarvuTextu(0);
OknoPisRetezec(IDOKna,Text,10,26);
ButonVytvor(IDOkna,4*length(Text)-17,42,'Ano',6);
ButonVytvor(IDOkna,4*length(Text)+17,42,'Ne',7);
konec:=false;
Kl:=0;
repeat
MouseMove;
if (MouseClickOnButon(IDOkna,b[7])) or
   (MouseClickOnButon(IDOKna,b[0])) or
   (Kl = 27)                        then
   begin
   AnoNeOtazka:=Ne;
   konec:=true;
   end;
if (MouseClickOnButon(IDOKna,b[6])) or
   (Kl = 13) then
   begin
   AnoNeOtazka:=Ano;
   konec:=true;
   end;
if keypressed then Kl:=ord(readkey);
until konec;
OknoZavri(IDOkna);
w[i].Stav := Open;
   for j:=w[IDOkna].x1 to w[IDOkna].x2 do
       New(w[i].Obsah[j]);
ButonVytvor(i,w[i].x2-15-w[i].x1,1,'x',0);
OknoUloz(i,320-10-4*length(Text),170,320+10+4*length(Text),230);
end;
begin
WInitGraph(M640x400);
for j:=1 to 10 do
for i:=1 to 223 do
    WPutPixel(i+100,j+100,15);
NactiFont;
for i:=1 to 10 do
    begin
    w[i].Stav := Closed;
    end;
for i:=1 to 50 do
    Txt[i].Obsah:='';
Aritmeticke_operace:=false;
end.